function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import classNames from 'classnames';
import Badgeable from '../badgeable';
import AvatarImage from './AvatarImage';
import AvatarInitials from './AvatarInitials';
import UnknownUserAvatar from './UnknownUserAvatar';
import GlobeBadge16 from '../../icon/fill/GlobeBadge16';
import './Avatar.scss';
var SIZES = {
  small: true,
  large: true
};

function Avatar(_ref) {
  var _ref2;

  var avatarUrl = _ref.avatarUrl,
      className = _ref.className,
      name = _ref.name,
      id = _ref.id,
      isExternal = _ref.isExternal,
      _ref$shouldShowExtern = _ref.shouldShowExternal,
      shouldShowExternal = _ref$shouldShowExtern === void 0 ? false : _ref$shouldShowExtern,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? '' : _ref$size;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      hasImageErrored = _React$useState2[0],
      setHasImageErrored = _React$useState2[1];

  var _React$useState3 = React.useState(null),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      prevAvatarUrl = _React$useState4[0],
      setPrevAvatarUrl = _React$useState4[1];

  var classes = classNames(['avatar', className, (_ref2 = {}, _defineProperty(_ref2, "avatar--".concat(size), size && SIZES[size]), _defineProperty(_ref2, 'avatar--isExternal', shouldShowExternal && isExternal), _ref2)]); // Reset hasImageErrored state when avatarUrl changes

  if (avatarUrl !== prevAvatarUrl) {
    setHasImageErrored(false);
    setPrevAvatarUrl(avatarUrl);
  }

  var avatar;

  if (avatarUrl && !hasImageErrored) {
    avatar = /*#__PURE__*/React.createElement(AvatarImage, {
      onError: function onError() {
        setHasImageErrored(true);
      },
      url: avatarUrl
    });
  } else if (name) {
    avatar = /*#__PURE__*/React.createElement(AvatarInitials, {
      id: id,
      name: name
    });
  } else {
    avatar = /*#__PURE__*/React.createElement(UnknownUserAvatar, {
      className: "avatar-icon"
    });
  }

  return /*#__PURE__*/React.createElement(Badgeable, {
    className: classes,
    bottomRight: shouldShowExternal && isExternal ? /*#__PURE__*/React.createElement(GlobeBadge16, {
      className: "bdl-Avatar-externalBadge"
    }) : undefined
  }, /*#__PURE__*/React.createElement("span", {
    role: "presentation"
  }, avatar));
}

export default Avatar;
//# sourceMappingURL=Avatar.js.map