import * as React from 'react';
import GuideTooltip from './GuideTooltip';
import Button from '../button/Button';
import FolderShared32 from '../../icon/content/FolderShared32';
import notes from './GuideTooltip.stories.md';

var addSpacing = function addSpacing(component) {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      textAlign: 'center'
    }
  }, component);
};

export var allOptions = function allOptions() {
  return addSpacing( /*#__PURE__*/React.createElement(GuideTooltip, {
    title: "Lorem Ipsum",
    body: "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",
    icon: /*#__PURE__*/React.createElement(FolderShared32, null),
    steps: [1, 3]
    /* eslint-disable no-console */
    ,
    primaryButtonProps: {
      children: 'Next',
      onClick: function onClick() {
        return console.log('next');
      }
    },
    secondaryButtonProps: {
      children: 'Back',
      onClick: function onClick() {
        return console.log('back');
      }
    }
    /* eslint-enable no-console */

  }, /*#__PURE__*/React.createElement(Button, null, "example")));
};
allOptions.story = {
  name: 'body, icon, steps, title, next button, previous button'
};
export var noButtons = function noButtons() {
  return addSpacing( /*#__PURE__*/React.createElement(GuideTooltip, {
    title: "Lorem Ipsum",
    body: "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",
    icon: /*#__PURE__*/React.createElement(FolderShared32, null),
    steps: [1, 3]
  }, /*#__PURE__*/React.createElement(Button, null, "example")));
};
noButtons.story = {
  name: 'body, icon, steps, title'
};
export var onlyTitleBody = function onlyTitleBody() {
  return addSpacing( /*#__PURE__*/React.createElement(GuideTooltip, {
    title: "Lorem Ipsum",
    body: "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua."
  }, /*#__PURE__*/React.createElement(Button, null, "example")));
};
onlyTitleBody.story = {
  name: 'only title and body'
};
export var onlyBody = function onlyBody() {
  return addSpacing( /*#__PURE__*/React.createElement(GuideTooltip, {
    body: "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua."
  }, /*#__PURE__*/React.createElement(Button, null, "example")));
};
onlyBody.story = {
  name: 'only body'
};
export default {
  title: 'Components|GuideTooltip',
  component: GuideTooltip,
  parameters: {
    notes: notes
  }
};
//# sourceMappingURL=GuideTooltip.stories.js.map