import * as React from 'react';
import Tooltip from '../tooltip';
import { useIsContentOverflowed } from '../../utils/dom';

var Title = function Title(_ref) {
  var title = _ref.title;
  // $FlowFixMe
  var textRef = React.useRef(null);
  var isTextOverflowed = useIsContentOverflowed(textRef);
  return /*#__PURE__*/React.createElement(Tooltip, {
    isDisabled: !isTextOverflowed,
    text: title
  }, /*#__PURE__*/React.createElement("div", {
    ref: textRef,
    className: "thumbnail-card-title"
  }, title));
};

var ThumbnailCardDetails = function ThumbnailCardDetails(_ref2) {
  var actionItem = _ref2.actionItem,
      icon = _ref2.icon,
      subtitle = _ref2.subtitle,
      title = _ref2.title;
  return /*#__PURE__*/React.createElement("div", {
    className: "thumbnail-card-details"
  }, icon, /*#__PURE__*/React.createElement("div", {
    className: "thumbnail-card-details-content"
  }, /*#__PURE__*/React.createElement("div", {
    className: "ThumbnailCardDetails-bodyText"
  }, /*#__PURE__*/React.createElement(Title, {
    title: title
  }), subtitle && /*#__PURE__*/React.createElement("div", {
    className: "thumbnail-card-subtitle"
  }, subtitle)), actionItem));
};

export default ThumbnailCardDetails;
//# sourceMappingURL=ThumbnailCardDetails.js.map